jest.dontMock('../ProjectManagement.jsx');

describe('ProjectManagement', function() {

  it('should render a login page when no session exists', function() {

    var Session = require('../../stores/Session.js');

    var React = require('react/addons');
    var ProjectManagement = require('../ProjectManagement.jsx');
    var TestUtils = React.addons.TestUtils;

    var Login = require('../Login.jsx');

    var ui = TestUtils.renderIntoDocument(
      <ProjectManagement />
    );

    var login = TestUtils.findRenderedComponentWithType(ui, Login);

    expect(login).toBeDefined();
  });

  it('renders the project list when the session exists and' +
    ' location indicates projectList: my', function() {

    var Session = require('../../stores/Session.js');
    var Location = require('../../stores/Location.js');

    var React = require('react/addons');
    var ProjectManagement = require('../ProjectManagement.jsx');
    var TestUtils = React.addons.TestUtils;

    var ProjectList = require('../ProjectList.jsx');

    Session.hasSession.mockReturnValueOnce(true);
    Location.getLocation.mockReturnValue({ projectList: 'my' });

    var ui = TestUtils.renderIntoDocument(
      <ProjectManagement />
    );

    var list = TestUtils.findRenderedComponentWithType(ui, ProjectList);

    expect(list).toBeDefined();
  });

  it('renders the project list when the session exists and' +
    ' location indicates projectList: all', function() {

    var Session = require('../../stores/Session.js');
    var Location = require('../../stores/Location.js');

    var React = require('react/addons');
    var ProjectManagement = require('../ProjectManagement.jsx');
    var TestUtils = React.addons.TestUtils;

    var ProjectList = require('../ProjectList.jsx');

    Session.hasSession.mockReturnValueOnce(true);
    Location.getLocation.mockReturnValue({ projectList: 'my' });

    var ui = TestUtils.renderIntoDocument(
      <ProjectManagement />
    );

    var list = TestUtils.findRenderedComponentWithType(ui, ProjectList);

    expect(list).toBeDefined();
  });

  it('renders the project details page when a session exists and' +
    ' location indicates project', function() {

    var Session = require('../../stores/Session.js');
    var Location = require('../../stores/Location.js');

    var React = require('react/addons');
    var ProjectManagement = require('../ProjectManagement.jsx');
    var TestUtils = React.addons.TestUtils;

    var ProjectDetails = require('../ProjectDetails.jsx');

    Session.hasSession.mockReturnValueOnce(true);
    Location.getLocation.mockReturnValue({ project: 'example' });

    var ui = TestUtils.renderIntoDocument(
      <ProjectManagement />
    );

    var details = TestUtils.findRenderedComponentWithType(ui, ProjectDetails);

    expect(details).toBeDefined();
  });

  it('renders the create project page when a session exists and' +
    ' location indicates project', function() {

    var Session = require('../../stores/Session.js');
    var Location = require('../../stores/Location.js');

    var React = require('react/addons');
    var ProjectManagement = require('../ProjectManagement.jsx');
    var TestUtils = React.addons.TestUtils;

    var CreateProject = require('../CreateProject.jsx');

    Session.hasSession.mockReturnValueOnce(true);
    Location.getLocation.mockReturnValue({ createProject: true });

    var ui = TestUtils.renderIntoDocument(
      <ProjectManagement />
    );

    var wizard = TestUtils.findRenderedComponentWithType(ui, CreateProject);

    expect(wizard).toBeDefined();
  });
});
